﻿

--[[

		$title:			Natur Enemy Castbar
		$author:		Michael Boyle (Softrix)
		$email:			michael.boyle@softrix.co.uk
		$website:		www.softrix.co.uk
		
		$credits:		This Natur Enemy Castbar is a complete rewrite based on the 
						excellent discontinued addon by Naturfreund.

						Credits also go to Shadowed who is the author of the GTB bar 
						library which I	have modified for this addon.  The original 
						unmodified GTB library for the purpose of these credits is at:
						
						http://www.wowinterface.com/downloads/info10204-GTB-1.0.html
						
						I was going to write my own bar routines until i came across
						his excellent library.. why re-invent the wheel as they say!
						
						Updated to 4.3 and first released 9/12/2011  =)
		
]]--

--
--	1.	spell id
--	2.	cooldown
--	3.	glyph
--	4.	crowd control
--	5.	diminish return
--	6.	warn (rogue)
--

--[[

	It is not possible to detect your targets glyphs or talents which would adjust
	these durations therefore the values below are base values.
	
	Michael.

]]--

Natur_AbilityInfo = {

	-- Priest
	{ 88685, 40, nil, false, false, false },					-- holy word: sanctuary
	{ 8092, 8, nil, false, false, false },						-- mind blast
	{ 8122, 30, nil, false, false, false },						-- psychic scream
	{ 14914, 10, nil, false, false, false },					-- holy fire
	{ 88684, 10, nil, false, false, false },					-- holy word: serenity
	{ 586, 30, nil, false, false, false },						-- fade
	{ 32379, 10, nil, false, false, false },					-- shadow word: death
	{ 6346, 180, nil, false, false, false },					-- fear ward
	{ 64901, 360, nil, false, false, false },					-- hymn of hope
	{ 34433, 300, nil, false, false, false },					-- Shadowfiend
	{ 33076, 10, nil, false, false, false },					-- prayer of mending
	{ 64843, 480, nil, false, false, false },					-- divine hymn
	{ 73325, 90, nil, false, false, false },					-- Leap of faith
	
	-- warlock
	{ 74434, 45, nil, false, false, false },					-- soulburn
	{ 79268, 30, nil, false, false, false },					-- soul harvest
	{ 6229, 30, nil, false, false, false },						-- shadow ward
	{ 6789, 120, nil, false, false, false },					-- death coil
	{ 698, 120, nil, false, false, false },						-- ritual of summoning
	{ 5484, 40, nil, false, true, false },						-- howl of terror
	{ 1122, 600, nil, false, false, false },					-- summon infernal
	{ 18540, 600, nil, false, false, false },					-- summon doomguard
	{ 50589, 30, nil, false, false, false },					-- immolation aura
	{ 29858, 120, nil, false, false, false },					-- soul shatter
	{ 29893, 300, nil, false, false, false },					-- ritual of souls
	{ 47897, 12, nil, false, false, false },					-- shadowflame
	{ 48020, 30, nil, false, false, false },					-- demonic circle: teleport
	{ 77801, 120, nil, false, false, false },					-- demon soul
	{ 5782, nil, nil, true, true, false },						-- fear
	
	-- shaman
	{ 73899, 8, nil, false, false, false },						-- primal strike
	{ 8042, 8, nil, false, false, false },						-- earthshock
	{ 8050, 6, nil, false, false, false },						-- flame shock
	{ 57994, 15, nil, false, false, false },					-- windshear
	{ 2484, 15, nil, false, false, false },						-- earthbind totem
	{ 8056, 6, nil, false, false, false },						-- frost shock
	{ 556, 45, nil, false, false, false },						-- astral recall
	{ 51505, 8, nil, false, false, false },						-- lava burst
	{ 8177, 25, nil, false, false, false },						-- grounding totem
	{ 8143, 60, nil, false, false, false },						-- tremor totems
	{ 2062, 600, nil, false, false, false },					-- earth elemental
	{ 5730, 20, nil, false, false, false },						-- stoneclaw totem
	{ 2894, 600, nil, false, false, false },					-- fire elemental
	{ 2825, 300, nil, false, false, false },					-- blood lust
	{ 32182, 300, nil, false, false, false },					-- heroism
	{ 51514, 45, nil, true, false, false },						-- hex
	{ 73680, 15, nil, false, false, false },					-- unleash elements
	{ 73920, 10, nil, false, false, false },					-- healing rain
	{ 79206, 120, nil, false, false, false },					-- spiritwalkers grace
	
	-- mage
	{ 2136, 8, nil, false, false, false },						-- fire blast
	{ 122, 25, nil, false, false, false },						-- frost nova
	{ 2139, 24, nil, false, false, false },						-- counterspell
	{ 12051, 240, nil, false, false, false },					-- evocation
	{ 1953, 15, nil, false, false, false },						-- blink
	{ 120, 10, nil, false, false, false },						-- cone of cold
	{ 45438, 300, nil, false, false, false },					-- ice block
	{ 55342, 180, nil, false, false, false },					-- mirror image
	{ 66, 180, nil, false, false, false },						-- invisibility
	{ 82731, 60, nil, false, false, false },					-- flame orb		
	{ 82676, 120, nil, false, false, false },					-- ring of frost	
	{ 118, 50, nil, true, true, false },						-- polymorph
	{ 28271, 50, nil, true, true, false },						-- poly turtle
	{ 28272, 50, nil, true, true, false },						-- poly pig
	{ 61305, 50, nil, true, true, false },						-- poly black cat
	{ 61025, 50, nil, true, true, false },						-- poly serpent
	{ 61721, 50, nil, true, true, false },						-- poly rabbit
	{ 61780, 50, nil, true, true, false },						-- poly turkey

	-- paladin
	{ 35395, 3.5, nil, false, false, false },					-- crusader strike
	{ 20271, 8, nil, false, false, false },						-- judgement
	{ 85673, 20, nil, false, false, false },					-- word of glory
	{ 853, 60, nil, false, false, false },						-- hammer of justice
	{ 62124, 8, nil, false, false, false },						-- hand of reckoning
	{ 633, 600, nil, false, false, false },						-- lay on hands
	{ 1022, 300, nil, false, false, false },					-- hand of protection	
	{ 26573, 30, nil, false, false, false },					-- consecration
	{ 2812, 15, nil, false, false, false },						-- holy wrath
	{ 498, 60, nil, false, false, false },						-- divine protection
	{ 24275, 6, nil, false, false, false },						-- hammer of wrath
	{ 642, 300, nil, false, false, false },						-- divine shield
	{ 1044, 25, nil, false, false, false },						-- hand of freedom
	{ 96231, 10, nil, false, false, false },					-- Rebuke
	{ 31884, 180, nil, false, false, false },					-- avenging wrath
	{ 6940, 120, nil, false, false, false },					-- hand of sacrifice
	{ 20066, 60, nil, false, false, false },					-- repentance
	
	-- deathknight
	{ 50977, 60, nil, false, false, false },					-- death gate
	{ 46584, 180, nil, false, false, false },					-- raise dead
	{ 47528, 10, nil, false, false, false },					-- mind freeze
	{ 47476, 120, nil, false, false, false },					-- strangulate
	{ 43265, 30, nil, false, false, false },					-- death and decay
	{ 48792, 180, nil, false, false, false },					-- icebound fortitude	
	{ 45529, 60, nil, false, false, false },					-- bloot tap
	{ 56222, 8, nil, false, false, false },						-- dark command
	{ 48743, 120, nil, false, false, false },					-- death pact
	{ 48707, 45, nil, false, false, false },					-- antimagic shell
	{ 61999, 600, nil, false, false, false },					-- raise ally
	{ 47568, 300, nil, false, false, false },					-- empower rune weapon
	{ 42650, 600, nil, false, false, false },					-- army of the dead
	{ 77575, 60, nil, false, false, false },					-- outbreak
	{ 77606, 60, nil, false, false, false },					-- dark simulacrum

	-- hunter
	{ 2973, 6, nil, false, false, false },						-- raptor strike
	{ 5116, 5, nil, false, false, false },						-- concussive shot	
	{ 34026, 6, nil, false, false, false },						-- kill command
	{ 781, 25, nil, false, false, false },						-- disengage
	{ 19503, 30, nil, false, false, false },					-- scatter shot
	{ 13795, 30, nil, false, false, false },					-- immolation trap
	{ 1499, 30, nil, true, false, false },						-- freezing trap
	{ 60192, 30, nil, false, false, false },					-- trap launcher
	{ 5384, 30, nil, false, false, false },						-- feign death
	{ 53351, 10, nil, false, false, false },					-- kill shot
	{ 13813, 30, nil, false, false, false },					-- fire trap
	{ 1543, 20, nil, false, false, false },						-- flare
	{ 13809, 30, nil, false, false, false },					-- ice trap
	{ 20736, 8, nil, false, false, false },						-- distracting shot
	{ 3045, 300, nil, false, false, false },					-- rapid fire
	{ 34600, 30, nil, false, false, false },					-- snake trap
	{ 53271, 45, nil, false, false, false },					-- masters call
	{ 34477, 30, nil, false, false, false },					-- misdirection
	{ 19263, 120, nil, false, false, false },					-- deterrence
	{ 51753, 60, nil, false, false, false },					-- camourflage

	-- druid
	{ 467, 45, nil, false, false, false },						-- thorns
	{ 5215, 10, nil, false, false, false },						-- prowl
	{ 6795, 8, nil, false, false, false },						-- growl
	{ 6807, 3, nil, false, false, false },						-- maul
	{ 779, 3, nil, false, false, false },						-- swipe (bear)
	{ 20484, 600, nil, false, false, false },					-- rebirth
	{ 5229, 60, nil, false, false, false },						-- enrage
	{ 80964, 60, nil, false, false, false },					-- skull bash (bear)
	{ 80965, 60, nil, false, false, false },					-- skull bash (cat)
	{ 5217, 30, nil, false, false, false },						-- tigers fury
	{ 8998, 10, nil, false, false, false },						-- cower
	{ 1850, 180, nil, false, false, false },					-- dash
	{ 5209, 180, nil, false, false, false },					-- challenging roar
	{ 29166, 180, nil, false, false, false },					-- innervate
	{ 5211, 60, nil, false, false, false },						-- bash
	{ 16689, 60, nil, false, false, false },					-- natures grasp
	{ 22812, 60, nil, false, false, false },					-- barkskin
	{ 22570, 10, nil, false, false, false },					-- maim
	{ 740, 480, nil, false, false, false },						-- tranquility
	{ 77758, 6, nil, false, false, false },						-- Thrash
	{ 77761, 120, nil, false, false, false },					-- stampeding roar (bear)
	{ 77764, 120, nil, false, false, false },					-- stampeding roar (cat)
	{ 88751, 10, nil, false, false, false },					-- wild mushroom: detonate
	{ 22842, 180, nil, false, false, false },					-- frenzied regen
	{ 339, nil, nil, true, true, false },						-- entangling roots

	-- warrior
	{ 88161, 3, nil, false, false, false },						-- strike
	{ 100, 15, nil, false, false, false },						-- charge
	{ 6343, 6, nil, false, false, false },						-- thunderclap
	{ 355, 8, nil, false, false, false },						-- taunt
	{ 78, 3, nil, false, false, false },						-- heroic strike
	{ 6673, 60, nil, false, false, false },						-- battle shout
	{ 57755, 60, nil, false, false, false },					-- heroic throw
	{ 2565, 60, nil, false, false, false },						-- shield block
	{ 676, 60, nil, false, false, false },						-- disarm		
	{ 1680, 10, nil, false, false, false },						-- whirlwind		
	{ 6552, 10, nil, false, false, false },						-- pummel				
	{ 6572, 5, nil, false, false, false },						-- revenge			
	{ 5246, 120, nil, false, false, false },					-- intimidating shout											
	{ 1161, 120, nil, false, false, false },					-- challenging shout				
	{ 871, 300, nil, false, false, false },						-- shield wall
	{ 20252, 30, nil, false, false, false },					-- intercept
	{ 18499, 30, nil, false, false, false },					-- beserker rage
	{ 1134, 30, nil, false, false, false },						-- inner rage
	{ 20230, 300, nil, false, false, false },					-- retaliation
	{ 1719, 300, nil, false, false, false },					-- recklessness
	{ 23920, 25, nil, false, false, false },					-- spell reflect
	{ 469, 60, nil, false, false, false },						-- commanding shout
	{ 3411, 30, nil, false, false, false },						-- intervene
	{ 64382, 300, nil, false, false, false },					-- shattering throw
	{ 55694, 180, nil, false, false, false },					-- enraged regeneration
	{ 86346, 20, nil, false, false, false },					-- colossus smash
	{ 97462, 180, nil, false, false, false },					-- rallying cry
	{ 6544, 60, nil, false, false, false },						-- heroic leap
	{ 1161, 120, nil, false, false, false },

	-- rogue
	{ 408, 20, nil, false, false, true },						-- kidney shot
	{ 51722, 60, nil, false, false, true },						-- dismantle	
	{ 1766, 10, nil, false, false, true },						-- kick	
	{ 1776, 10, nil, false, false, true },						-- Gouge
	{ 2983, 60, nil, false, false, true },						-- sprint
	{ 1966, 10, nil, false, false, true },						-- feint
	{ 1856, 180, nil, false, false, true },						-- vanish
	{ 1725, 30, nil, false, false, true },						-- distract
	{ 2094, 180, nil, false, false, true },						-- blind
	{ 31224, 120, nil, false, false, true },					-- cloak of shadows
	{ 57934, 30, nil, false, false, true },						-- tricks of the trade.
	{ 73981, 60, nil, false, false, true },						-- redirect	
	{ 1784, 6, nil, false, false, true },						-- stealth	
	{ 5277, 180, nil, false, false, true },						-- evasion		
	{ 6770, nil, nil, true, true, true },						-- sap
	{ 76577, 180, nil, false, false, true },					-- smoke bomb	
	{ 1833, 4, nil, false, true, true },						-- cheap shot	
	{ 73651, nil, nil, false, false, true },					-- recuperate	
		
};


--
--	Process Spell Information
--	Returns:  spell_id, cooldown, glyph, crowd control, diminish return, rogue warn, spell icon
--
function Natur_ProcessAbilityFired(spellid, guid)
	for count,value in ipairs(Natur_AbilityInfo) do 
		if(value[1] == spellid) then
			-- found the spell im interested in.
			local _,_, icon,_,_,_,_,_,_ = GetSpellInfo(spellid);
			return value[1], value[2], value[3], value[4], value[5], value[6], icon;
		end;
	end;	-- end of loop
end;